import es
import wcs.wcs 

info = es.AddonInfo()
info.author = 'Ojii'
info.version = '2'

es.ServerVar('wcsa_version', info.version).makepublic()

es.load("myo_achievement")
achievementManager = es.import_addon("myo_achievement")

achievements = achievementManager.AchievementGroup("wcsa", "WarCraft: Source Achievements", "Achievements for WarCraft: Source")

achievements["xp"] = ("Ah so this is an Experience Point!","Gain 1 XP",1)
achievements["noob"] = ("Noob", "Gain 300 XP.", 300)
achievements["rookie"] = ("Rookie", "Gain 500 XP.", 500)
achievements["skilled"] = ("Skilled", "Gain 1000 XP.", 1000)
achievements["kiddie"] = ("This joke is old", "Gain 1337 XP.", 1337)
achievements["veteran"] = ("Veteran", "Gain 5000 XP.", 5000)
achievements['experienced'] = ('Experienced','Gain 10000 XP.', 10000)
achievements['getalife'] = ('Get a life!','Gain 1000000 XP.', 1000000)
xpgroup = ['xp','noob','rookie','skilled','kiddie','veteran','experienced','getalife']

achievements['Human Alliance'] = ("Look at my Avatar","Use the Avatar ultimate",1)
achievements['Night Elf'] = ("Entangled!","Use the Entangle ultimate",1)
achievements['Orcish Horde'] = ("Beautiful Storm","Use the Chain Lightning ultimate",1)
achievements['Pandaren Brewmaster'] = ("Elementalist","Use the Storm, Earth and Fire ultimate",1)
achievements['Priestess of the Moon'] = ("Man in the Moon","Use the Moon Glaive ultimate",1)
achievements['Shadow Hunter'] = ("Put a needle in the puppet","Use the Big Bad Voodo ultimate",1)
achievements['Undead Scourge'] = ("Life sucks!","Use the Suicide Bomber ultimate",1)
achievements['Warden'] = ("Vengance is mine","Use the Avatar of Vengance ultimate",1)
ultigroup = ['Human Alliance','Night Elf','Orcish Horde','Pandaren Brewmaster','Priestess of the Moon','Shadow Hunter','Undead Scourge','Warden']

killers = {}
achievements['orc1'] = ("Only a dead Orc is a good Orc", "Kill an Orc", 1)
achievements['orc2'] = ("All the Orcs must die", "Kill 20 Orcs", 20)
achievements['orc3'] = ("Paint the world in green blood", "Kill 100 Orcs", 100)
killers['Orcish Horde'] = ['orc1','orc2','orc3']

achievements['human1'] = ("Homizide", "Kill a Human", 1)
achievements['human2'] = ("Serial Killer", "Kill 20 Humans", 20)
achievements['human3'] = ("Deathnote Owner", "Kill 100 Humans", 100)
killers['Human Alliance'] = ['human1','human2','human3']

achievements['nightelf1'] = ("I don't like pointy ears!", "Kill a Night Elf", 1)
achievements['nightelf2'] = ("Go hug trees in hell!", "Kill 20 Night Elves", 20)
achievements['nightelf3'] = ("Eternal life isn't as eternal as you might think!", "Kill 100 Night Elves", 100)
killers['Night Elf'] = ['nightelf1','nightelf2','nightelf3']

achievements['pandaren1'] = ("I always wanted a panda cape!", "Kill a Pandaren Brewmaster", 1)
achievements['pandaren2'] = ("Alcohol kills!", "Kill 20 Pandaren Brewmasters", 20)
achievements['pandaren3'] = ("I was at the Octoberfest and all I got is 100 kills!", "Kill 100 Pandaren Brewmasters", 100)
killers['Pandaren Brewmaster'] = ['pandaren1','pandaren2','pandaren3']

achievements['priestess1'] = ("Mmmh Priestess Blood", "Kill a Priestess of the Moon", 1)
achievements['priestess2'] = ("Moonlight on the grave", "Kill 20 Priestesses of the Moon", 20)
achievements['priestess3'] = ("Priestess Hater", "Kill 100 Priestesses of the Moon", 100)
killers['Priestess of the Moon'] = ['priestess1','priestess2','priestess3']

achievements['shadowhunter1'] = ("Go back to the shadows", "Kill a Shadow Hunter", 1)
achievements['shadowhunter2'] = ("Hunter becomes prey", "Kill 20 Shadow Hunters", 20)
achievements['shadowhunter3'] = ("Endless Hunt", "Kill 100 Shadow Hunters", 100)
killers['Shadow Hunter'] = ['shadowhunter1','shadowhunter2','shadowhunter3']

achievements['undead1'] = ("I thought you were undead!", "Kill an Undead", 1)
achievements['undead2'] = ("Kill the dead!", "Kill 20 Undeads", 20)
achievements['undead3'] = ("You only die 200 times", "Kill 100 Undeads", 100)
killers['Undead Scourge'] = ['undead1','undead2','undead3']

achievements['warden1'] = ("Die Warden!", "Kill a Warden", 1)
achievements['warden2'] = ("Shouldn't the Assasin rather kill than die?", "Kill 20 Wardens", 20)
achievements['warden3'] = ("Assasin Assasinator", "Kill 100 Wardens", 100)
killers['Warden'] = ['warden1','warden2','warden3']

achievements['samerace1'] = ("I thought we were friends :(", "Get killed by someone with the same race", 1)
achievements['samerace2'] = ("Hey you're my brother!", "Get killed by someone with the same race 20 times", 20)
achievements['samerace3'] = ("I feel like a black sheep", "Get killed by someone with the same race 100 times", 100)
samerace = ['samerace1','samerace2','samerace3']

achievements['developer'] = ("ZOMFG IT IS HIM!!!", "Play with a WCS Developer", 1)

achievements['shopoholic1'] = ("Girl" , "Buy 100$ worth of items.", 100)
achievements['shopoholic2'] = ("Teenage Girl", "Buy 1000$ worth of items.", 1000)
achievements['shopoholic3'] = ("Woman", "Buy 10000$ worth of items.", 10000)
achievements['shopoholic4'] = ("Wife", "Buy 1000000$ worth of items.", 1000000)
shopoholic = ['shopoholic1','shopoholic2','shopoholic3','shopoholic4']

achievements["Mask of Death"] = ("Life Leecher","Buy one Mask of Death",1)
achievements["Claws of Attack"] = ("Wolverine","Buy one Claws of Attack",1)
achievements["Necklace of Protection"] = ("Mirror","Buy one Necklace of Protection",1)
achievements["Ankh of Reincarnation"] = ("Weapon Recycler","Buy one Ankh of Reincarnation",1)
achievements["Life Preserver"] = ("MEDIC","Buy one Life Preserver",1)
achievements["Dust of Appearance"] = ("Show me where you are","Buy one Dust of Appearance",1)
achievements["Tomb of Health"] = ("Mystical Medic","Buy one Tomb of Health",1)
achievements["Socks of Feathers"] = ("Float like a feather","Buy one Socks of Feathers",1)
achievements["Flaming Glove of Warmth"] = ("Burn in hell","Buy one Flaming Glove of Warmth",1)
achievements["Heavy Boots of Armor"] = ("I'm a tank","Buy one Heavy Boots of Armor",1)
achievements["Periapt of Health"] = ("Vital Signs Up","Buy one Periapt of Health",1)
achievements["Helmet of Clear View"] = ("Sunglasses look cool","Buy one Helmet of Clear View",1)
achievements["Mole"] = ("Mole","Buy one Mole",1)
achievements["Disguiser"] = ("Wolf in sheepskin","Buy one Disguiser",1)
achievements["Potion of Invulnerability"] = ("This doesn't hurt","Buy one Potion of Invulnerability",1)
achievements["Stone of Health"] = ("This Rocks","Buy one Stone of Health",1)
achievements["Long Jump"] = ("I believe I can fly","Buy one Long Jump",1)
achievements["Ring of Regeneration"] = ("This feels good","Buy one Ring of Regeneration",1)
achievements["Cloak of Shadows I"] = ("Try to see me now","Buy one Cloak of Shadows I",1)
achievements["Cloak of Shadows II"] = ("Try even harder to see me now","Buy one Cloak of Shadows II",1)
achievements["Orb of Frost"] = ("I'm so cool","Buy one Orb of Frost",1)
achievements["Scroll of Respawning"] = ("You only live twice","Buy one Scroll of Respawning",1)
achievements["Helmet of Protection"] = ("My Helmet Reflects My Personality","Buy one Helmet of Protection",1)
achievements["Ring of Armor"] = ("Bling Bling","Buy one Ring of Armor",1)
achievements["Boots of Speed"] = ("Usain Bolt","Buy one Boots of Speed",1)
achievements["Potion of Healing"] = ("Doping","Buy one Potion of Healing",1)
achievements["Tome of Xp"] = ("Cheap Leveler","Buy one Tome of Xp",1)
achievements["Off the Shell Boots"] = ("Foot Fetish","Buy one Off the Shell Boots",1)
achievements["Helmet of Excellence"] = ("Excellent Protection","Buy one Helmet of Excellence",1)
achievements["Secondary Clip Enhancement"] = ("Viagra for your gun","Buy one Secondary Clip Enhancement",1)
achievements["Lightning Flash"] = ("Flashy!","Buy one Lightning Flash",1)
items = ['Mask of Death','Claws of Attack','Necklace of Protection','Ankh of Reincarnation','Life Preserver','Dust of Appearance','Tomb of Health','Socks of Feathers','Flaming Glove of Warmth','Heavy Boots of Armor','Periapt of Health','Helmet of Clear View','Mole','Disguiser','Potion of Invulnerability','Stone of Health','Long Jump','Ring of Regeneration','Cloak of Shadows II','Cloak of Shadows I','Orb of Frost','Scroll of Respawning','Helmet of Protection','Ring of Armor','Boots of Speed','Potion of Healing','Tome of Xp','Off the Shell Boots','Helmet of Excellence','Secondary Clip Enhancement','Lightning Flash']

achievements["achiever"] = ("The Achiever Achievement", "Complete all WCS Achievements", 79)

def wcs_gainxp(ev):
    for a in xpgroup:
        achievements[a].stepProgressForPlayer(ev['userid'],int(ev['amount']))

def player_ultimate_on(ev):
    playerrace = wcs.GetRace(ev['userid'])
    if playerrace in ultigroup:
        achievements[playerrace].stepProgressForPlayer(ev['userid'])    

def achievement_achieved(ev):
    if ev["achievementgroupid"] == "wcsa":
        es.tell(ev["playerid"], "You have completed the '%s' achievement!" % achievements[ev["achievementid"]].name)
        if not ev['achievementid'] == 'achiever':
            achievements['achiever'].stepProgressForPlayer(ev['playerid'])

def player_death(ev):
    victim = ev['userid']
    attacker = ev['attacker']
    victimrace = wcs.GetRace(victim)
    attackerrace = wcs.GetRace(attacker)
    if victimrace in killers:
        for a in killers[playerrace]:
            achievements[a].stepProgressForPlayer(attacker)
        if victimrace == attackerrace:
            for a in samerace:
                achievements[a].stepProgressForPlayer(victim)

def player_spawn(ev):
    if ev['es_steamid'] in ('STEAM_0:0:7663580','STEAM_0:1:10717798'):
        for userid in es.getUseridList():
            achievements['developer'].stepProgressForPlayer(userid)

def item_bought(ev):
    for a in shopoholic:
        achievements[a].stepProgressForPlayer(ev['userid'],ev['cost'])
    if ev['item'] in items:
        achievements[ev['item']].stepProgressForPlayer(ev['userid'])
